<?php

namespace App\Http\Controllers;
use Illuminate\Support\Facades\DB;
use Illuminate\Http\Request;

class option_one_controller extends Controller
{     
    
            public function calculateAmount(Request $request)
            {
            $currentDate = now()->format('Y-m-d');  
            $currentDate_his = now()->format('Y-m-d g:i:s');
            $output = DB::table('member')
            ->where('group_id', $request->group_id)
            ->first();
        
            if (!$output) {
                return response()->json(['error' => 'Group not found'], 404);
            }
        
            $AmountAll_USD = 0;
            $totalAmountKH = 0;
            $AmountAll_TH = 0;
            $totalAmountTH = 0;
        
            // Cambodian bank only
            if ($output->bank_id == 1 && $output->option_bank == 0) {
                $queryUSD = DB::table('data_from_bank')
                ->where('group_id', $request->group_id);
        
                if ($request->start && $request->end) {
                    $queryUSD->whereBetween('date_tran', [$request->start, $request->end]);
                }else if($request -> time != null){
                    $startDateTime = $currentDate . ' 00:00:00';
                    $endDateTime = $currentDate .' '.$request -> time .':00:00';
                    $queryUSD->whereBetween('date_tran', [$startDateTime, $endDateTime]);
                }else {
                    $queryUSD->whereDate('date_tran', $currentDate);
                }
        
                $AmountAll_USD = $queryUSD->sum('amount');
                $totalAmountKH = $AmountAll_USD * 4000;
                // $message = $AmountAll_USD;
                $AmountAll_TH = -1;
                $totalAmountTH = -1;
            }
            // Thai bank only
            elseif ($output->bank_id == 2 && $output->option_bank == 0) {
                $queryTH = DB::table('data_from_bankthai')
                ->where('group_id', $request->group_id);
                if ($request->start && $request->end) {
                    $queryTH->whereBetween('date_tran', [$request->start, $request->end]);
                }else if($request -> time != null){
                    $startDateTime = $currentDate . ' 00:00:00';
                    $endDateTime = $currentDate .' '.$request -> time .':00:00';
                    $queryTH->whereBetween('date_tran', [$startDateTime, $endDateTime]);
                }else {
                    $queryTH->whereDate('date_tran', $currentDate);
                }
             
                $AmountAll_TH = $queryTH->sum('amount');
                $totalAmountTH = $output->exchange_rate != 0
                    ? ($AmountAll_TH * $output->fee * 0.01) / $output->exchange_rate
                    : 0;
        
                $AmountAll_USD = -1;
                $totalAmountKH = -1;
            }
            // Both banks selected
            elseif ($output->option_bank == 1) {
                $queryUSD = DB::table('data_from_bank')->where('group_id', $request->group_id);
                $queryTH = DB::table('data_from_bankthai')->where('group_id', $request->group_id);
                if ($request->start && $request->end) {
                    $queryUSD->whereBetween('date_tran', [$request->start, $request->end]);
                     $queryTH->whereBetween('date_tran', [$request->start, $request->end]);
                }else if($request -> time != null){
                    $startDateTime = $currentDate . ' 00:00:00';
                    $endDateTime = $currentDate .' '.$request -> time .':00:00';
                    $queryUSD->whereBetween('date_tran', [$startDateTime, $endDateTime]);
                    $queryTH->whereBetween('date_tran', [$startDateTime, $endDateTime]);
                }else {
                    $queryUSD->whereDate('date_tran', $currentDate);
                    $queryTH->whereDate('date_tran', $currentDate);
                }
                
           
        
                $AmountAll_USD = $queryUSD->sum('amount');
                $AmountAll_TH = $queryTH->sum('amount');
        
                $totalAmountKH = $AmountAll_USD * 4000;
                $totalAmountTH = $output->exchange_rate != 0
                    ? ($AmountAll_TH * $output->fee * 0.01) / $output->exchange_rate
                    : 0;
            }
            
            return response()->json([[
                'group_id' => $request->group_id,
                'exchange_rate' => $output->exchange_rate,
                'fee' => $output->fee,
                'total_amount_kh_usd' => $AmountAll_USD,
                'total_amount_kh_khr' => round($totalAmountKH, 2),
                'total_amount_th_bat' => $AmountAll_TH,
                'total_amount_th_usd' => round($totalAmountTH, 2),
            ]]);
        }

        //   public function calculateAmount(Request $request)
        // {
        //     $currentDate = now()->format('Y-m-d');   
        
        //     $output = DB::table('member')
        //         ->where('group_id', $request->group_id)
        //         ->first();
        
        //     if (!$output) {
        //         return response()->json([
        //             'error' => 'Group not found'
        //         ], 404);
        //     }
        
        //     // Default values
        //     $AmountUsd = 0;
        //     $totalAmountKH = 0;
        //     $AmountTH = 0;
        //     $totalAmountTH = 0;
        
        //     // Only Cambodian bank selected
        //     if ($output->bank_id == 1 && $output->option_bank == 0) {
        //         $AmountUsd = DB::table('data_from_bank')
        //             ->where('date_tran', $currentDate)
        //             ->where('group_id', $request->group_id)
        //             ->sum('amount');
        
        //         $totalAmountKH = $AmountUsd * 4000; // Change 4000 if you need dynamic rate
        
        //         // Mark Thai side as not applicable
        //         $AmountTH = -1;
        //         $totalAmountTH = -1;
        //     }
        
        //     // Only Thai bank selected
        //     elseif ($output->bank_id == 2 && $output->option_bank == 0) {
        //         $AmountTH = DB::table('data_from_bankthai')
        //             ->where('date_tran', $currentDate)
        //             ->where('group_id', $request->group_id)
        //             ->sum('amount');
        
        //         if ($output->exchange_rate != 0) {
        //             $totalAmountTH = ($AmountTH * $output->fee * 0.01) / $output->exchange_rate;
        //         }
        
        //         // Mark USD side as not applicable
        //         $AmountUsd = -1;
        //         $totalAmountKH = -1;
        //     }
        
        //     // Both banks selected
        //     elseif ($output->option_bank == 1) {
        //         // Cambodian bank
        //         $AmountUsd = DB::table('data_from_bank')
        //             ->where('date_tran', $currentDate)
        //             ->where('group_id', $request->group_id)
        //             ->sum('amount');
        
        //         $totalAmountKH = $AmountUsd * 4000;
        
        //         // Thai bank
        //         $AmountTH = DB::table('data_from_bankthai')
        //             ->where('date_tran', $currentDate)
        //             ->where('group_id', $request->group_id)
        //             ->sum('amount');
        
        //         if ($output->exchange_rate != 0) {
        //             $totalAmountTH = ($AmountTH * $output->fee * 0.01) / $output->exchange_rate;
        //         }
        //     }
        
        //     // Return results
        //     return response()->json([
        //       [
        //         'group_id' => $request->group_id,
        //         'exchange_rate' => $output->exchange_rate,
        //         'fee' => $output->fee,
        //         'total_amount_kh_usd' => $AmountUsd,
        //         'total_amount_kh_khr' => round($totalAmountKH, 2),
        //         'total_amount_th_bat' => $AmountTH,
        //         'total_amount_th_usd' => round($totalAmountTH, 2),]
        //     ]);
        // }



        public function editRate_exchangeRate(Request $request){
            DB::table('member')
            ->where('group_id',$request->group_id)
            ->update([
            'member_name' => $request -> member_name,
            'fee' => $request -> fee,
            'exchange_rate' => $request->exchange_rate
            ]);
            return response()->json([
                'message' => "Edit Rate/Exchange Successfuly",
            ]); 
        }
        
           public function listData_groupID(Request $request){
             $currentDate = now()->format('Y-m-d');  
            $currentDate_his = now()->format('Y-m-d g:i:s');  
            $groupID = $request->input('group_id');
            $output = DB::table('member')->where('group_id', $request->group_id)->first();
            if($output->bank_id == 1 && $output->option_bank == 0){
                 $queryUSD = DB::table('data_from_bank')
                ->where('group_id', $request->group_id);
               if ($request->start && $request->end) {
                    $queryUSD->whereBetween('date_tran', [$request->start, $request->end]);
                }else if($request -> time != null){
                    $startDateTime = $currentDate . ' 00:00:00';
                    $endDateTime = $currentDate .' '.$request -> time .':00:00';
                    $queryUSD->whereBetween('date_tran', [$startDateTime, $endDateTime]);
                }else {
                    $queryUSD->whereDate('date_tran', $currentDate);
                }
                $data = $queryUSD->get();
            }else if($output->bank_id == 2 && $output->option_bank == 0){
                 $queryTH = DB::table('data_from_bankthai')
                ->where('group_id', $request->group_id);
                if ($request->start && $request->end) {
                    $queryTH->whereBetween('date_tran', [$request->start, $request->end]);
                }else if($request -> time != null){
                    $startDateTime = $currentDate . ' 00:00:00';
                    $endDateTime = $currentDate .' '.$request -> time .':00:00';
                    $queryTH->whereBetween('date_tran', [$startDateTime, $endDateTime]);
                }else {
                    $queryTH->whereDate('date_tran', $currentDate);
                }
                 $data = $queryTH->get();
            }else{
               $data = DB::select("
                SELECT id, bank_name, amount, name,currency,group_name,date_tran
                FROM data_from_bank 
                WHERE group_id = ?
                
                UNION ALL
                
                SELECT id, bank_name, amount, name,currency,group_name,date_tran 
                FROM data_from_bankthai 
                WHERE group_id = ?
            ", [$groupID, $groupID]); 
            }
            
        
            return response()->json($data);
        }
        // public function listData_groupID(Request $request){
        //     $groupID = $request->input('group_id');
        
        //     $output = DB::select("
        //         SELECT id, bank_name, amount, name,currency,group_name,date_tran
        //         FROM data_from_bank 
        //         WHERE group_id = ?
                
        //         UNION ALL
                
        //         SELECT id, bank_name, amount, name,currency,group_name,date_tran 
        //         FROM data_from_bankthai 
        //         WHERE group_id = ?
        //     ", [$groupID, $groupID]);
        
        //     return response()->json($output);
        // }



    
           public function listMember(Request $request){
            $output = DB::select("
                SELECT *
                FROM (
                    SELECT * FROM data_from_bank
                    UNION ALL
                    SELECT * FROM data_from_bankthai
                ) as combined
                WHERE id = (
                    SELECT MAX(id)
                    FROM (
                        SELECT * FROM data_from_bank
                        UNION ALL
                        SELECT * FROM data_from_bankthai
                    ) as sub
                    WHERE sub.group_id = combined.group_id
                )
                AND NOT EXISTS (
                    SELECT 1 FROM member WHERE member.group_id = combined.group_id
                )
                ORDER BY id DESC
            ");
        
            return response()->json($output);
        }



    public function addMember(Request $request){
      $currentDate = now()->format('Y-m-d g:i:s');
      $member =  DB::table('member')
        ->where('group_id',$request->group_id)
        ->first();
        if(!$member){
          DB::table('member')
            ->insert([
            'group_id' => $request->group_id,
            'option_bank' => 0,
            'bank_id' => 0,
            'member_name' => $request->member_name,
            'group_name' => $request -> group_name,
            // 'fee' => $request -> fee,
            // 'exchange_rate' => $request->exchange_rate,
            'create_date' => $currentDate,
            ]);
            return response()->json([
                'message' => "Created User Successfuly",
            ]); 
        }else{
             return response()->json([
                'message' => "This User is already Exited",
            ]); 
        }
    }
    
    public function calculate_price_group(Request $request){
        $currentDate = now()->format('Y-m-d g:i:s');
        $output =  DB::table('member')
        ->leftJoin('money_member', 'member.group_id', '=', 'money_member.group_id')
        ->where('date_calculate', $currentDate)
        ->where('money_member.group_id',$request->group_id)
        ->first();
        if ($output){
            if($request->calculate_money > 0){
            $count_slips = $output->count_slips + 1;
            }else{
             $count_slips = $output->count_slips;   
            }
            DB::table('money_member')
            ->where('date_calculate', $currentDate)
            ->where('group_id',$request->group_id)
            ->update([
                'calculate_money' => ($output->calculate_money + $request->calculate_money),
                'count_slips' => $count_slips
            ]);
          $outputs = DB::table('money_member')
                ->where('date_calculate', $currentDate)
                ->where('group_id',$request-> group_id)
                ->first();
        return response()->json([
        'calculate_money' => $outputs ->calculate_money,
        'count_slips' => $outputs->count_slips,
        ]);
        }else{
        $member =  DB::table('member')
        ->where('group_id',$request->group_id)
        ->first();
        if(!$member){
          DB::table('member')
            ->insert([
            'group_id' => $request->group_id,
            'option_bank' => 0,
            'bank_id' => 0,
            'group_name' => $request->group_name,
            'create_date' => $currentDate,
            ]);  
        }    
            
            DB::table('money_member')
            ->insert([
            'group_id' => $request->group_id,
            'calculate_money' => 0,
            'count_slips' => 0,
            'date_calculate' => $currentDate
            ]);
        
            return response()->json([
                'calculate_money' => 0,
                'count_slips' => 0,
            ]); 
        }
    
    }
    public function calculate_amount(Request $request){
        $currentTime_Date_tele = now()->format('Y-m-d');
        $currentTime_Time_tele = now()->format('H:i:s');
        $currentDate = now()->format('Y-m-d g:i:s');
        if (preg_match('/[-+]?\d+\.\d+/', $request->amount, $matches)) {
            $amount = ltrim($matches[0], '+-');
        }
         
        switch($request->currency){
        case 'khr':
        $mount_calculate = ($amount)/4000;
        $currency_amount ="KHR";
        break;
        case 'usd':
        $mount_calculate = $amount;
        $currency_amount ="USD";
        break;
        }
        $output =  DB::table('data_from_bank')
        ->insert([
        'bank_name' => $request->bank_name,
        'bank_id' => $request->bank_id,
        'amount' => $mount_calculate,
        'name' => $request->name,
        'currency' => $request->currency,
        'group_id' => $request->group_id,
        'group_name' => $request->group_name,
        'date_tran' => $currentDate  
        ]);
        $count_payslips =  DB::table('data_from_bank')
        ->where('group_id',$request->group_id)
        ->count();
        // All Amount Total
        // $totalAmount = DB::table('data_from_bank')
        // ->where('date_tran',$currentDate)
        // ->where('group_id',$request->group_id)
        // ->sum('amount');
        $curl = curl_init();
        curl_setopt_array($curl, array(
        CURLOPT_URL => 'https://api.telegram.org/bot7669003420:AAGKhS6k8bTDxzNQR3_6cmnRPSkEgA8Xt0s/sendMessage',
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'POST',
        CURLOPT_POSTFIELDS => json_encode(array(
            "chat_id" => $request->group_id,
            "text" => "<b>🔄 PaySlips of number</b>\t\t:\t\t".$count_payslips."\n".
                      "<b>🏦 Bank</b>\t\t:\t\t".$request->bank_name."\n".
                      "<b>👤 Title</b>\t\t:\t\t".$request->name."\n".
                      "<b>💵 Amount</b>\t\t:\t\t".$amount." ".$currency_amount."\n".
                    //   "<b>🟢 Total Amount</b>\t\t:\t\t".$totalAmount.'$'."\n".
                      "<b>🗓 Date Transection</b>\t\t:\t\t".$currentTime_Date_tele."\t-\t".$currentTime_Time_tele,
             "parse_mode" => "HTML"
        )),
        CURLOPT_HTTPHEADER => array(
            'Content-Type: application/json'
        )
            ));
            
            $response = curl_exec($curl);
            curl_close($curl);
    
        

        return response()->json([
            'message' => "Successfuly",
            ]);
    }
      public function calculate_amount_thai(Request $request){
        $currentTime_Date_tele = now()->format('Y-m-d');
        $currentTime_Time_tele = now()->format('H:i:s');
        $currentDate = now()->format('Y-m-d g:i:s');
        $output =  DB::table('data_from_bankthai')
        ->insert([
        'bank_name' => $request->bank_name,
        'bank_id' => $request->bank_id,
        'amount' => $request->amount,
        'name' => $request->name,
        'currency' => 'bat',
        'group_id' => $request->group_id,
        'group_name' => $request->group_name,
        'date_tran' => $currentDate  
        ]);
        $count_payslips =  DB::table('data_from_bankthai')
        ->where('group_id',$request->group_id)
        ->count();
        // All Amount Total
        // $totalAmount = DB::table('data_from_bankthai')
        // ->where('date_tran',$currentDate)
        // ->where('group_id',$request->group_id)
        // ->sum('amount');
        $curl = curl_init();
        curl_setopt_array($curl, array(
        CURLOPT_URL => 'https://api.telegram.org/bot7669003420:AAGKhS6k8bTDxzNQR3_6cmnRPSkEgA8Xt0s/sendMessage',
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'POST',
        CURLOPT_POSTFIELDS => json_encode(array(
            "chat_id" => $request->group_id,
            "text" => "<b>🔄 PaySlips of number</b>\t\t:\t\t".$count_payslips."\n".
                      "<b>🏦 Bank</b>\t\t:\t\t".$request->bank_name."\n".
                      "<b>👤 Title</b>\t\t:\t\t".$request->name."\n".
                      "<b>💵 Amount</b>\t\t:\t\t".$request->amount."\tบาท"."\n".
                    //   "<b>🟢 Total Amount</b>\t\t:\t\t".$totalAmount."\tบาท"."\n".
                      "<b>🗓 Date Transection</b>\t\t:\t\t".$currentTime_Date_tele."\t-\t".$currentTime_Time_tele,
             "parse_mode" => "HTML"
        )),
        CURLOPT_HTTPHEADER => array(
            'Content-Type: application/json'
        )
            ));
            
            $response = curl_exec($curl);
            curl_close($curl);
    
        

        return response()->json([
            'message' => "Successfuly",
            ]);
    }
}
